with Ada.Text_IO,Reps.IO;
use Ada.Text_IO,Reps.IO;

pragma Elaborate_All (Ada.Text_IO);

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Taylors.IO is

   procedure Show(H: in Taylor; Cut: in Rep := Zero);    -- Show coeffs of H  (of modulus>Cut)
   procedure Put(F: in File_Type; H: in  Taylor;         -- Write H to file F
                 Decimal: in Boolean := True);
   procedure Write(Name: in String; H: in Taylor;        -- Write H to file Name
                   Decimal: in Boolean := True);
--   procedure Get(F: in File_Type; H: out Taylor;         -- Read H from file F
--                 Decimal: in Boolean := True);
--   procedure Read(Name: in String; H: out Taylor;        -- Read H from file Name
--                  Decimal: in Boolean := True);

end Taylors.IO;
