generic

  with function Scal(K: Integer) return Scalar is <>;
  with function Scal(R1,R2: Rep) return Scalar is <>;
  with function Ball(R: Rep) return Scalar is <>;
  with function Inf(S: Scalar) return Rep is <>;
  with function Sup(S: Scalar) return Rep is <>;
  with function InfAbs(S: Scalar) return Rep is <>;
  with function SupAbs(S: Scalar) return Rep is <>;
  with function Norm(S: Scalar) return Scalar is <>;
  with function Min(S1,S2: Scalar) return Scalar is <>;
  with function Max(S1,S2: Scalar) return Scalar is <>;
  with function "<"(S1,S2: Scalar) return Boolean is <>;
  with function "abs"(S: Scalar) return Scalar is <>;

  with function "-"(S: Scalar) return Scalar is <>;
  with function "+"(S,T: Scalar) return Scalar is <>;
  with function "-"(S,T: Scalar) return Scalar is <>;
  with function "*"(R: Rep; S: Scalar) return Scalar is <>;
  with function "/"(S: Scalar; R: Rep) return Scalar is <>;
  with function Sqr(S: Scalar) return Scalar is <>;
  with function Log(S: Scalar) return Scalar is <>;
  with function Exp(S: Scalar) return Scalar is <>;
  with function "*"(S,T: Scalar) return Scalar is <>;
  with function Inv(S: Scalar) return Scalar is <>;
  with function "/"(S,T: Scalar) return Scalar is <>;
  with function "**"(S: Scalar; I: Integer) return Scalar is <>;

package Taylors.Ops is

  procedure Neg(P: in out Taylor);                                      -- return -P
  function "-"(P: Taylor) return Taylor;                                -- -P
  procedure Mult(S: in Scalar; P: in out Taylor);                       -- P := S*P
  procedure Prod(S: in Scalar; P1: in Taylor; P2: out Taylor);          -- P2 := S*P1;
  function "*"(S: Scalar; P: Taylor) return Taylor;                     -- return S*P
  procedure Add(P1: in Taylor; P2: in out Taylor);                      -- P2 := P2+P1
  procedure Sum(P1,P2: in Taylor; P3: out Taylor);                      -- P3 := P1+P2
  function "+"(P1,P2: Taylor) return Taylor;                            -- return P1+P2
  procedure MultAdd(S: in Scalar; P1: in Taylor; P2: in out Taylor);    -- P2 := P2+S*P1
  procedure Sub(P1: in Taylor; P2: in out Taylor);                      -- P2 := P2-P1
  procedure Diff(P1,P2: in Taylor; P3: out Taylor);                     -- P3 := P1-P2
  function "-"(P1,P2: Taylor) return Taylor;                            -- return P1-P2
  procedure Mult(R: in Radius; P1: in Taylor; P2: in out Taylor);       -- P2 := P2*P1
  procedure Prod(R: in Radius; P1,P2: in Taylor; P3: out Taylor);       -- P3 := P1*P2;
  procedure MultAdd(R: in Radius; P1,P2: in Taylor; P3: in out Taylor); -- P3 := P3+P1*P2
  function "abs"(P: Taylor) return Taylor;                              -- abs of coeffs
  function Val(R: Radius; S: Scalar; P: Taylor) return Scalar;          -- return P(s)
  function Norm(R: Radius; P: Taylor) return Scalar;                    -- return |P|
  function ExpTrunc(N: Integer; L: Scalar) return Taylor;               -- E_n(l t)
  function Exp(R: Radius; S: Taylor) return Taylor;                     -- Exp(S)
  function D(R1,R2: Radius; P: Taylor) return Taylor;                   -- D(P) X_R1->X_R2
  function Dm1(R: Radius; P: Taylor) return Taylor;                     -- inverse derivative
  function Ball(R: Radius) return Taylor;

end Taylors.Ops;
